"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from datetime import datetime
from typing import (
    Optional,
    Required,
    TypedDict,
)

from pydantic import Field, StrictInt, StrictStr

from .. import DevopnessBaseModel


class ActionTargetLogStep(DevopnessBaseModel):
    """
    ActionTargetLogStep

    Attributes:
        order (int): The execution order of the given step
        started_at (datetime): The date and time when the step started execution (i.e., left the &#x60;pending/queued&#x60; status)
        completed_at (datetime): The date and time when the step has finished execution
        output (str): The full text output log
    """

    order: StrictInt = Field(description="The execution order of the given step")
    started_at: Optional[datetime] = Field(
        description="The date and time when the step started execution (i.e., left the `pending/queued` status)"
    )
    completed_at: Optional[datetime] = Field(
        description="The date and time when the step has finished execution"
    )
    output: Optional[StrictStr] = Field(description="The full text output log")


class ActionTargetLogStepPlain(TypedDict, total=False):
    """
    Plain version of ActionTargetLogStep.
    """

    order: Required[int]
    started_at: Required[datetime]
    completed_at: Required[datetime]
    output: Required[str]
