"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from typing import (
    Optional,
    TypedDict,
    Union,
)

from pydantic import Field, StrictBool, StrictStr

from .. import DevopnessBaseModel
from .resource_type import ResourceType, ResourceTypePlain


class ResourceTypeRelated(DevopnessBaseModel):
    """
    ResourceTypeRelated

    Attributes:
        resource_type (ResourceType, optional):
        resource_type_human_readable (str, optional): Human readable version of the resource type name
        resource_type_human_readable_plural (str, optional): Plural human readable version of the resource type name
        can_be_linked (bool, optional): If true, the relation with this resource type can be changed manually by the user
    """

    resource_type: Optional[ResourceType] = None
    resource_type_human_readable: Optional[StrictStr] = Field(
        default=None, description="Human readable version of the resource type name"
    )
    resource_type_human_readable_plural: Optional[StrictStr] = Field(
        default=None,
        description="Plural human readable version of the resource type name",
    )
    can_be_linked: Optional[StrictBool] = Field(
        default=None,
        description="If true, the relation with this resource type can be changed manually by the user",
    )


class ResourceTypeRelatedPlain(TypedDict, total=False):
    """
    Plain version of ResourceTypeRelated.
    """

    resource_type: Optional[
        Union[
            ResourceType,
            ResourceTypePlain,
        ]
    ]
    resource_type_human_readable: Optional[str]
    resource_type_human_readable_plural: Optional[str]
    can_be_linked: Optional[bool]
