"""
Devopness API Python SDK - Painless essential DevOps to everyone

Note:
    This is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
"""

from datetime import datetime
from typing import (
    Optional,
    TypedDict,
    Union,
)

from pydantic import Field, StrictInt, StrictStr

from .. import DevopnessBaseModel
from .server_blueprint_spec import ServerBlueprintSpec, ServerBlueprintSpecPlain


class ServerBlueprint(DevopnessBaseModel):
    """
    ServerBlueprint

    Attributes:
        id (int, optional): The unique id of the blueprint
        name (str, optional): Name of the blueprint
        type (str, optional): The blueprint type
        spec (ServerBlueprintSpec, optional):
        created_at (datetime, optional): The date and time when the record was created
        updated_at (datetime, optional): The date and time when the record was last updated
    """

    id: Optional[StrictInt] = Field(
        default=None, description="The unique id of the blueprint"
    )
    name: Optional[StrictStr] = Field(default=None, description="Name of the blueprint")
    type: Optional[StrictStr] = Field(default=None, description="The blueprint type")
    spec: Optional[ServerBlueprintSpec] = None
    created_at: Optional[datetime] = Field(
        default=None, description="The date and time when the record was created"
    )
    updated_at: Optional[datetime] = Field(
        default=None, description="The date and time when the record was last updated"
    )


class ServerBlueprintPlain(TypedDict, total=False):
    """
    Plain version of ServerBlueprint.
    """

    id: Optional[int]
    name: Optional[str]
    type: Optional[str]
    spec: Optional[
        Union[
            ServerBlueprintSpec,
            ServerBlueprintSpecPlain,
        ]
    ]
    created_at: Optional[datetime]
    updated_at: Optional[datetime]
